package ipl;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
import futils.utils.*;

public class FloatImage {
	public float r[];
	public float g[];
	public float b[];
	private int width;
	private int height;
	ColorModel cm ;
	ProcessPlane pp;
	
public FloatImage(int l) {
	// these are set with values
	// that are wrong, but enable the 
	// accessor methods to work
	width = l;
	height = 1; 

	r = new float[l];
	g = new float[l];
	b = new float[l];

}
	
	
public FloatImage(ProcessPlane pp_) {
	pp = pp_;
	width = pp.getWidth();
	height = pp.getHeight();
	int l = width*height;
	r = new float[l];
	g = new float[l];
	b = new float[l];
	cm = ColorModel.getRGBdefault();
	for (int i=0; i < l; i++) {
		r[i] = (float) pp.getRed(i);
		g[i] = (float) pp.getGreen(i);
		b[i] = (float) pp.getBlue(i);
	}
}

public ProcessPlane makeProcessPlane() {

	for (int i =0; i < r.length; i++) {
		pp.setPixel(i,(int) r[i],(int) g[i], (int) b[i],255);
	}
	return pp;
}		
public int getLength() {
	return r.length;
}
public int getHeight() {
	return height;
}
public int getWidth() {
	return width;
}

public float getRed(int i) {
	return r[i];
}

public float getGreen(int i) {
	return g[i];
}

public float getBlue(int i) {
	return b[i];
}

public float getAlpha(int i) {
	return (float) pp.getAlpha(i);
}


public float getRed(int x, int y) {
		if (inrange(x,y)) {
			return getRed(y*width + x);
			}
		else {return 0;}
	}

public float getGreen(int x, int y) {
		if (inrange(x,y)) {
			return getGreen (y*width + x);
						}
		else {return 0;}

	}
	
public float getBlue(int x, int y) {
			if (inrange(x,y)) {
				return getBlue  (y*width + x);
									}
		else {return 0;}

	}
	
public float getAlpha(int x, int y) {
			if (inrange(x,y)) {
					return getAlpha (y*width + x);
													}
		else {return 0;}
}


boolean inrange(int x, int y) {
	return ((x < width) && (y < height));
}
	
public void setPixel(int x, int y, 
	float r_, float g_, float b_) {
	int i = y * width + x;
	r[i] = r_;
	g[i] = g_;
	b[i] = b_;
}

public void setPixel(int i, float r_, float g_, float b_) {
	r[i] = r_;
	g[i] = g_;
	b[i] = b_;
}
	
public void printSize() {
		System.out.println(
			"W:"+
			width +
			" H:"+ 
			height);
}

// Maximum of R,G and B
public float max(int i) {
      if (r[i] > g[i]) {
         if (r[i] > b[i])
            return(r[i]);
         else
            return(b[i]);
      }
      else {
         if (g[i] > b[i])
            return(g[i]);
         else
            return(b[i]);
      }
}

// Minimum of R,G and B
public float min(int i) {
	if (r[i] < g[i]) {
    	if (r[i] < b[i])
            return(r[i]);
         else
            return(b[i]);
    }
    else {
         if (g[i] < b[i])
            return(g[i]);
         else
            return(b[i]);
    }
 }
 


}