/*
   Solid1.java
   Three Dimensional Figures
   By Roger t. Stevens  1-31-97    
*/
package solid;
import java.awt.*;
import futils.bench.*; // for the timer

class SolidCanvas extends Canvas 
{
   SolidCanvas(Color col) 
   {
   }

   public void paint(Graphics g) 
   {
       System.out.println("Paint begins");
       Timer t2 = new Timer();
       t2.mark();     
      g.setColor(new Color(190, 190, 255));
      g.fillRect(0,0,640,260);
      g.setColor(new Color(90, 255, 90));
      g.fillRect(0,260,640,220);
      Cylinder cy = new Cylinder();
      cy.sc = new VecDouble(20.0, 30.0, 20.0); 
      cy.tr = new VecDouble(-200.0, 0.0, -60.0);     
      cy.color = new Color(50, 255, 255);
      cy.paint(g);
      Cone cone = new Cone();
      cone.no_facets = 4;
      cone.sc = new VecDouble(40.0, 60.0, 40.0); 
      cone.tr = new VecDouble(-200, 0.0, 0.0);     
      cone.color = new Color(255, 255, 40);
      cone.paint(g);
      Cone cone1 = new Cone();
      Cube cube = new Cube();
      cube.sc = new VecDouble(50.0, 50.0, 50.0);
      cube.tr = new VecDouble(100.0, 0.0, 0.0);
          
      cube.paint(g);
      double  r= 30.0;
      double s= -130.0;
      cy.sc = new VecDouble(r,r,1.5*r);
      cy.tr = new VecDouble(r, 0.293*r, -s-4.6*r);
      cy.color = new Color(255,255,0);
      cy.paint(g);
      Sphere sp = new Sphere();
      sp.sc = new VecDouble(50.0, 50.0, 50.0); 
      sp.tr = new VecDouble(-50.0, 30.0, 0.0);
      sp.paint(g);     
       cy.tr = new VecDouble(-2*r, 0.293*r, -s-3.5*r);
      cy.color = new Color(0, 255, 0);
      cy.paint(g);
      cy.sc = new VecDouble(r,r,1.5*r);
      cy.tr = new VecDouble(0.0, -1.8*r, -s-4.1*r);
      cy.color = new Color(0, 0, 255);
      cy.paint(g);
 
      cone1.no_facets = 180;
      cone1.sc = new VecDouble(32.0,32.0,32.0);
      cone1.tr = new VecDouble(132.0, -150.0, -3.2);
      cone1.color = new Color(0,0,255);
      cone1.paint(g);
      cone1.tr = new VecDouble(100.0, -208.0, -3.2);
      cone1.color = new Color(0,255,255);
      cone1.paint(g);
      cone1.tr = new VecDouble(60.0, -170.0, -3.2);   
      cone1.color = new Color(255, 0, 0);
      cone1.paint(g);
      Sphere sphere = new Sphere();
      sphere.sc = new VecDouble(43.6,43.6,43.6);
      sphere.tr = new VecDouble(100.0, -170.0, -57.6);
      sphere.color = new Color(0,255,0);
      sphere.paint(g);
      SolidRev pawn = new SolidRev();
      pawn.color = new Color(255, 255, 255);
      pawn.sc = new VecDouble(50.0, 50.0, 50.0);
      pawn.tr = new VecDouble(-20.0, -130.0, 0.0);
      pawn.paint(g,0); 
      SolidRev bishop = new SolidRev();
      bishop.color = new Color(255, 0, 255);
      bishop.sc = new VecDouble(50.0, 50.0, 50.0);
      bishop.tr = new VecDouble(-120.0, -100.0, 0.0);
      bishop.paint(g,1);
      SolidRev pin = new SolidRev();
      pin.color = new Color(255, 150, 255);
      pin.sc = new VecDouble(60.0, 60.0, 60.0);
      pin.tr = new VecDouble(25.0, -170.0, 50.0);
      pin.paint(g,2); 
      t2.record();
      t2.report();
  }
}

class SolidStuff
{
   int   angle=30, tilt=18;
   double light_phi = 25.0;
   double light_theta = 45.0;
   double SA = -Math.sin(0.017453292*angle);
   double CA = -Math.cos(0.017453292*angle);
   double CT = Math.cos(0.017453292*tilt);
   double ST = Math.sin(0.017453292*tilt);
   VecDouble pers = new VecDouble(0.0, -10.0, 550.0);
   double ViewerDist = 550.;
   VecDouble Viewer = new VecDouble(-CT * CA, -CT * SA, ST);
   VecDouble light = new VecDouble(Math.sin(0.017453292*light_theta) *
      Math.cos(0.017453292*light_phi), Math.sin(0.017453292*light_theta) *
      Math.sin(0.017453292*light_phi), Math.cos(0.017453292*light_theta));
   int theta, d_theta, phi, no_facets, i,j;
   double sp1, cp1, sp2, cp2;
   Color color = new Color(255, 100, 100);
   VecDouble facet3D1, facet3D2, facet3D3, facet3D4;
   VecDouble temp1 = new VecDouble();
   VecDouble temp2 = new VecDouble();
   VecDouble tr = new VecDouble();
   VecDouble sc = new VecDouble(); 
   VecDouble ro = new VecDouble();
   Matrix trans = new Matrix();;
   
   public void DisplayFacet(Graphics g, VecDouble facet3D1, VecDouble facet3D2,
      VecDouble facet3D3, VecDouble facet3D4)
   {
      double ambient=0.30;
      double diffuse=0.70;
      double specular=0.5;
      double glossiness=5.0;
      double cos_theta, cos_alpha, cos_beta;
      VecDouble temp = new VecDouble();
      VecDouble surf_norm = new VecDouble();
      double intensity;
      int i,j;
      Polygon poly = new Polygon();
      Matrix Rotator = new Matrix (SA, -CA, 0, 0,
         CA*ST, SA*ST, CT, 0, CA*CT, SA*ST, -ST, 0, 0, 0, 0, 1);
      surf_norm = surf_norm.surface_normal(facet3D1, facet3D2, 
         facet3D3, facet3D4);
      cos_beta = Viewer.dotvec(Viewer, surf_norm);     
      if (cos_beta >= 0.0)
      {
         cos_theta = surf_norm.dotvec(surf_norm, light);
         if(cos_theta<=0.0)
            intensity = ambient;
         else
         {
            temp = temp.subvec(surf_norm, light);
            temp = temp.scalemult(2.0*cos_theta, temp);
            cos_alpha = Math.max(0.0,Viewer.dotvec(Viewer, temp));
            intensity = Math.max(0.0, Math.min(1.0,ambient + diffuse * 
               cos_theta + specular * Math.pow(cos_alpha, glossiness)));
         }
         temp = Rotator.MatCrossVec(facet3D1, Rotator);
         temp = temp.addvec(pers, temp);
         poly.addPoint (320 + (int)(ViewerDist * temp.x/temp.z), 
            240 - (int)( ViewerDist * temp.y/temp.z));   
         temp = Rotator.MatCrossVec(facet3D2, Rotator);
         temp = temp.addvec(pers, temp);
         poly.addPoint (320 + (int)(ViewerDist * temp.x/temp.z), 
            240 - (int)( ViewerDist * temp.y/temp.z));   
         temp = Rotator.MatCrossVec(facet3D3,Rotator);
         temp = temp.addvec(pers, temp);
         poly.addPoint (320 + (int)(ViewerDist * temp.x/temp.z), 
            240 - (int)( ViewerDist * temp.y/temp.z));   
         temp = Rotator.MatCrossVec(facet3D4, Rotator);
         temp = temp.addvec(pers, temp);
         poly.addPoint (320 + (int)(ViewerDist * temp.x/temp.z), 
            240 - (int)( ViewerDist * temp.y/temp.z));   
         temp = Rotator.MatCrossVec(facet3D1, Rotator);
         temp = temp.addvec(pers, temp);
         poly.addPoint (320 + (int)(ViewerDist * temp.x/temp.z), 
            240 - (int)( ViewerDist * temp.y/temp.z));   
         g.setColor(new Color((int)(color.getRed()*intensity), (int)
            (color.getGreen()*intensity), (int)(color.getBlue()*
            intensity)));
         g.fillPolygon(poly); 
      }
   }
}

class Sphere extends SolidStuff
{
   public Sphere()
   {
   } 
   
   void paint(Graphics g)
   {
      trans = trans.transform(tr, sc, ro);      
      for (phi=0; phi<180; phi+=2)
      {  
         sp1=Math.sin((phi+2)*0.017453292);
         cp1=Math.cos((phi+2)*0.017453292);
         sp2=Math.sin((phi-1)*0.017453292);
         cp2=Math.cos((phi-1)*0.017453292);
         for (theta=-2; theta<360; theta+=2)
         {
            facet3D1 = new VecDouble((sp1*Math.cos((theta-2)*
               0.017453292)),(sp1*Math.sin((theta-2)*0.017453292)),
               cp1);
            facet3D1 = trans.MatCrossVec(facet3D1,trans);
            facet3D2 = new VecDouble((sp1*Math.cos((theta+2)*
               0.017453292)),(sp1*Math.sin((theta+2)*0.017453292)),
               cp1);
            facet3D2 = trans.MatCrossVec(facet3D2,trans);
            facet3D3 = new VecDouble((sp2*Math.cos((theta+2)*
               0.017453292)),(sp2*Math.sin((theta+2)*0.017453292)), 
               cp2);
            facet3D3 = trans.MatCrossVec(facet3D3,trans);
            facet3D4 = new VecDouble((sp2*Math.cos((theta-2)*
               0.017453292)),(sp2*Math.sin((theta-2)*0.017453292)), 
               cp2);
            facet3D4 = trans.MatCrossVec(facet3D4,trans);
            DisplayFacet(g, facet3D1,facet3D2, facet3D3, facet3D4);
         }
      }
   }
}     

class Cylinder extends SolidStuff
{
   public void Cylinder()
   {
   }
   
   public void paint(Graphics g)
   {
      trans = trans.transform(tr, sc, ro);
      for (theta=1; theta<360; theta+=2)
      {
         facet3D1 = new VecDouble((Math.cos((theta-1)*0.017453292)),
            (Math.sin((theta-1)*0.017453292)), -1.0);
         facet3D1 = trans.MatCrossVec(facet3D1,trans);
         facet3D2 = new VecDouble((Math.cos((theta+1)*0.017453292)),
            (Math.sin((theta+1)*0.017453292)), -1.0);
         facet3D2 = trans.MatCrossVec(facet3D2,trans);
         facet3D3 = new VecDouble((Math.cos((theta+1)*0.017453292)),
            (Math.sin((theta+1)*0.017453292)), 1.0);
         facet3D3 = trans.MatCrossVec(facet3D3,trans);
         facet3D4 = new VecDouble((Math.cos((theta-1)*0.017453292)),
            (Math.sin((theta-1)*0.017453292)), 1.0);
         facet3D4 = trans.MatCrossVec(facet3D4,trans);
         DisplayFacet(g, facet3D1, facet3D2, facet3D3, facet3D4);
         facet3D1 = new VecDouble((Math.cos((theta-1)*0.017453292)),
            (Math.sin((theta-1)*0.017453292)), 1.0);
         facet3D1 = trans.MatCrossVec(facet3D1,trans);
         facet3D2 = new VecDouble((Math.cos((theta+1)*0.017453292)),
            (Math.sin((theta+1)*0.017453292)), 1.0);
         facet3D2 = trans.MatCrossVec(facet3D2,trans);
         facet3D3 = new VecDouble((Math.cos((180-theta-1)*0.017453292)),
            (Math.sin((180-theta-1)*0.017453292)), 1.0);
         facet3D3 = trans.MatCrossVec(facet3D3,trans);
         facet3D4 = new VecDouble((Math.cos((180-theta+1)*0.017453292)),
            (Math.sin((180-theta+1)*0.017453292)), 1.0);
         facet3D4 = trans.MatCrossVec(facet3D4,trans);
         DisplayFacet(g, facet3D1, facet3D2, facet3D3, facet3D4);
      }
    
   }
}

class Cone extends SolidStuff
{
   public void Cone()
   {
   }

   public void paint(Graphics g)
   {
      trans = trans.transform(tr, sc, ro);
      d_theta = 360/no_facets;
    
      for (theta=-180; theta<180; theta+= d_theta)
      {
         facet3D1 = new VecDouble((Math.cos((theta)*0.017453292)),
            (Math.sin((theta)*0.017453292)), -1.0);
         facet3D1 = trans.MatCrossVec(facet3D1,trans);
         facet3D2 = new VecDouble((Math.cos((theta+d_theta)*0.017453292)),
            (Math.sin((theta+d_theta)*0.017453292)), -1.0);
         facet3D2 = trans.MatCrossVec(facet3D2,trans);
         facet3D3 = new VecDouble(0.0,0.0,1.0);
         facet3D3 = trans.MatCrossVec(facet3D3,trans);
         facet3D4 = new VecDouble(facet3D3.x, facet3D3.y, facet3D3.z);
         DisplayFacet(g, facet3D1, facet3D2, facet3D3, facet3D4);
      }
   }
}

class SolidRev extends SolidStuff
{
   public void SolidRev()
   {
   }
   
   public void paint(Graphics g, int type)
   {
      int i, j, theta, d_theta;
      double z_step, dz;
      double surface [] = new double[60];
     
      trans = trans.transform(tr, sc, ro);
      switch(type)
      {
         case 0:   /* pawn */
            for (i=0; i<10; i++)
               surface[i] = 0.2 + Math.sin(0.017453292 * (9 - i) * 12.0) * 0.5;
            for (i=10; i<43; i++)
               surface[i] = 0.2;
            for (i=43; i<60; i++)
               surface[i] = Math.sin(0.017453292 * (58 - i) * 9.0) * 0.6;
            break;
         case 1:   // bishop 
            for (i=0; i<10; i++)
               surface[i] = 0.2 + Math.sin(0.017453292 * (9 - i) * 12.0) * 0.5;
            for (i=9; i<38; i++)
               surface[i] = 0.3;
            for (i=38; i<60; i++)
               surface[i] = Math.sin(0.017453292 * (59 - i) * 6) * 0.45;
            break;
         case 2: // bowling pin 
            for (i=0; i<38; i++)
               surface[i] = -0.65 + Math.cos(0.017453292 * (i - 16)*1.5);
            for (i=38; i<56; i++)
               surface[i] = 0.2;
            for (i=56; i<60; i++)
               surface[i] =  Math.sin(0.017453292 * (59 - i) * 30.0) * 0.2;
            break;
      }
   
      dz = 1/60.0;
      d_theta = 1;
      
     for (j=0,z_step=dz-1.0; j<59; j++,z_step += 2.*dz)
     {
          for (theta = -180; theta<180; theta+=2)
         {
    
           facet3D1 = new VecDouble((Math.cos((theta-d_theta)*0.017453292))*
               surface[j], (Math.sin((theta-d_theta)*0.017453292))*
               surface[j], z_step - dz);
            facet3D1 = trans.MatCrossVec(facet3D1,trans);
            facet3D2 = new VecDouble((Math.cos((theta+d_theta)*0.017453292))*
               surface[j], (Math.sin((theta+d_theta)*0.017453292))*
               surface[j], z_step - dz);
            facet3D2 = trans.MatCrossVec(facet3D2,trans);
            facet3D3 = new VecDouble((Math.cos((theta+d_theta)*0.017453292))*
               surface[j+1], (Math.sin((theta+d_theta)*0.017453292))*
               surface[j+1], z_step + dz);
            facet3D3 = trans.MatCrossVec(facet3D3,trans);
            facet3D4 = new VecDouble((Math.cos((theta-d_theta)*0.017453292))*
               surface[j+1], (Math.sin((theta-d_theta)*0.017453292))*
               surface[j+1], z_step + dz);
            facet3D4 = trans.MatCrossVec(facet3D4,trans);
            DisplayFacet(g, facet3D1, facet3D2, facet3D3, facet3D4);
       
     }
       }
   }
}

class Cube extends SolidStuff
{
   public void Cube()
   {
   }
   
   public void paint(Graphics g)
   {
      int i;
      double side[][][] = {{{1.,1.,1.},{-1.,1.,1.},{-1.,-1.,1.},{1.,-1.,1.}},
         {{1.,1.,-1.},{1.,-1.,-1.},{-1.,-1.,-1.},{-1.,1.,-1.}},
         {{1.,1.,1.},{1.,-1.,1.},{1.,-1.,-1.},{1.,1.,-1.}},
         {{-1.,1.,1.},{-1.,1.,-1.},{-1.,-1.,-1.},{-1.,-1.,1.}},
         {{1.,1.,1.},{1.,1.,-1.},{-1.,1.,-1.},{-1.,1.,1.}},
         {{1.,-1.,1.},{-1.,-1.,1.},{-1.,-1.,-1.},{1.,-1.,-1.}}};

      trans = trans.transform(tr, sc, ro);
      for (i=5; i>=0; i--)
      {
         facet3D1 = new VecDouble(side[i][0][0],side[i][0][1],side[i][0][2]);
         facet3D1 = trans.MatCrossVec(facet3D1,trans);
         facet3D2 = new VecDouble(side[i][1][0],side[i][1][1],side[i][1][2]);
         facet3D2 = trans.MatCrossVec(facet3D2,trans);
         facet3D3 = new VecDouble(side[i][2][0],side[i][2][1],side[i][2][2]);
         facet3D3 = trans.MatCrossVec(facet3D3,trans);
         facet3D4 = new VecDouble(side[i][3][0],side[i][3][1],side[i][3][2]);
         facet3D4 = trans.MatCrossVec(facet3D4,trans);
         DisplayFacet(g, facet3D1, facet3D2, facet3D3, facet3D4);
      }
   }
}
 
public class Solid1 extends Frame 
{
   Color col = new Color(25, 25, 255);
   
   public Solid1() 
   {
      super("Three-dimensional modeling of solids");
      setBackground(Color.white);
      setLayout( new BorderLayout());
      add("Center", new SolidCanvas(col));
      resize(640, 480);
      show();
   }

   public boolean handleEvent(Event evt) 
   {
      if (evt.id == Event.WINDOW_DESTROY)
         System.exit(0);
      return super.handleEvent(evt);
   }
  
   public static void main(String args[]) 
   {
   	Timer t = new Timer();
   	t.mark();
      Solid1 f = new Solid1();
      t.record();
     t.report();
   }
}

class VecDouble
{
   double x, y, z;
   
   public VecDouble()
   {
   }
   
   public VecDouble(double X, double Y, double Z)
   {
      x = X;
      y = Y;
      z = Z;
   }

   public VecDouble addvec(VecDouble a,VecDouble b)
   {
      VecDouble c = new VecDouble();

      c.x = a.x + b.x;
      c.y = a.y + b.y;
      c.z = a.z + b.z;
      return(c);
   }

   public VecDouble subvec(VecDouble a,VecDouble b)
   {
      VecDouble c = new VecDouble();

      c.x = a.x - b.x;
      c.y = a.y - b.y;
      c.z = a.z - b.z;
      return(c);
   }

   public double dotvec(VecDouble a, VecDouble b)
   {
      return (a.x*b.x + a.y*b.y + a.z*b.z);
   }

   public VecDouble cross(VecDouble a, VecDouble b)
   {
      VecDouble c = new VecDouble();

      c.x = a.y*b.z - a.z*b.y;
      c.y = a.z*b.x - a.x*b.z;
      c.z = a.x*b.y - a.y*b.x;
      return(c);
   }

   public double lengthvec(VecDouble a)
   {
      return(Math.sqrt(a.x*a.x + a.y*a.y + a.z*a.z));
   }
 
    public VecDouble normvec()
   {
      double length;

      length = lengthvec(this);
      if (length == 0.0)
         return(this);
      this.x /= length;
      this.y /= length;
      this.z /= length;
      return(this);
   }
   
   public VecDouble scalemult(double r, VecDouble a)
   {
      VecDouble b = new VecDouble();

      b.x = r*a.x;
      b.y = r*a.y;
      b.z = r*a.z;
      return(b);
   }  
   
   public VecDouble surface_normal(VecDouble facet3D1, 
      VecDouble facet3D2, VecDouble facet3D3, VecDouble facet3D4)
   {
      double length1, length2;
      VecDouble dir1 = new VecDouble();
      VecDouble dir2 = new VecDouble();
      VecDouble srf_normal1 = new VecDouble();
      VecDouble srf_normal2 = new VecDouble();

      dir1 = subvec(facet3D2, facet3D1);
      dir2 = subvec(facet3D4,facet3D1);
      srf_normal1 = cross(dir1, dir2);
      length1 = lengthvec(srf_normal1);
      dir1 = subvec(facet3D4,facet3D3);
      dir2 = subvec(facet3D2,facet3D3);
      srf_normal2 = cross(dir1, dir2);
      length2 = lengthvec(srf_normal2);
      if(length1 == 0.0)
         srf_normal1 = srf_normal2.normvec();
      else
      {
         srf_normal1 = srf_normal1.normvec();
         if(length2 != 0.0)
         {
            srf_normal2 = srf_normal2.normvec();
            srf_normal1 = addvec(srf_normal1,srf_normal2);
            srf_normal1 = scalemult(0.5, srf_normal1);
         }
      }
      return(srf_normal1);
   }
}
   
class Matrix
{
   double [][] element = new double[4][4];
   
   public Matrix()
   {
   }

   public Matrix(double a0, double a1, double a2, double a3, double a4,
      double a5, double a6, double a7, double a8, double a9, double a10, 
      double a11, double a12, double a13, double a14, double a15)
   {    
      element[0][0] = a0;
      element[0][1] = a1;
      element[0][2] = a2;
      element[0][3] = a3;
      element[1][0] = a4;
      element[1][1] = a5;
      element[1][2] = a6;
      element[1][3] = a7;
      element[2][0] = a8;
      element[2][1] = a9;
      element[2][2] = a10;
      element[2][3] = a11;
      element[3][0] = a12;
      element[3][1] = a13;
      element[3][2] = a14;
      element[3][3] = a15;
   }         
   
   public VecDouble MatCrossVec(VecDouble a, Matrix m)
   {
      VecDouble b = new VecDouble();
      b.x = m.element[0][0]*a.x + m.element[0][1]*a.y + m.element[0][2]*a.z + 
         m.element[0][3];
      b.y = m.element[1][0]*a.x + m.element[1][1]*a.y + m.element[1][2]*a.z
         + m.element[1][3];
      b.z = m.element[2][0]*a.x + m.element[2][1]*a.y + m.element[2][2]*a.z
         + m.element[2][3];;
      return(b);
   }
  
   public Matrix rotate(int axis, double angle)
   {
      int i,j;
      Matrix a = new Matrix();
      double c,s;

      a.element[axis-1][axis-1] = 1.0;
      a.element[3][3] = 1.0;
      i = (axis % 3) + 1;
      j = i %3;
      i -= 1;
      c = Math.cos(angle * 0.017453292);
      s = Math.sin(angle * 0.017453292);
      a.element[i][i] = c;
      a.element[i][j] = s;
      a.element[j][j] = c;
      a.element[j][i] = -s;
      return(a);
   }
   
   public Matrix transform(VecDouble tr, VecDouble sc, VecDouble ro)
   {
       Matrix a1 = new Matrix();
       Matrix a2 = new Matrix(); 
       Matrix a3 = new Matrix();  
       Matrix a4 = new Matrix();  
       Matrix a5 = new Matrix();  
      Matrix temp = new Matrix();  
   
      a1 = scale(sc);
      a2 = rotate(1,ro.x);
      a3 = rotate(2,ro.y);
      a4 = rotate(3,ro.z);
      a5 = translate(tr);
      temp = mult_mat(a2,a1);
      temp = mult_mat(a3,temp);
      temp = mult_mat(a4,temp);
      temp = mult_mat(a5,temp);
      return(temp);
   }

   public Matrix translate(VecDouble a)
   {
      Matrix b = new Matrix();
      int i;

      for (i=0; i<4; i++)
         b.element[i][i] = 1.0;
      b.element[0][3] = -a.x;
      b.element[1][3] = -a.y;
      b.element[2][3] = -a.z;
      return(b);
   }

   public Matrix scale(VecDouble a)
   {
      Matrix b = new Matrix();

      b.element[0][0] = a.x;
      b.element[1][1] = a.y;
      b.element[2][2] = a.z;
      b.element[3][3] = 1.0;
      return(b);
   }
   public Matrix mult_mat2(Matrix b, Matrix a) {
   	Mat4 am = new Mat4(a.element);
   	Mat4 bm = new Mat4(b.element);
   	Mat4 cm = am.multiply(bm);
   	Matrix c = new Matrix();
   	c.element = cm.a;
   	return c;
   }


   public Matrix mult_mat(Matrix a, Matrix b)
   {
      int i,j,k;
      Matrix c = new Matrix();
      
 
      for (i=0; i<4; i++)
      {
         for (j=0; j<4; j++)
         {
            for (k=0; k<4; k++)
               c.element[i][j] += a.element[i][k]*b.element[k][j];
         }
      }
      return(c);
    }
}
